/*
 * AboutDialog - Dialog Procedure definition for rDialogAbout2
 * Copyright (c) 2002 by Project Waffle / TSUJIKAWA Tohru <tsujikawa@tsg.ne.jp>
 *  
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// AboutDialog.cpp


#include	<winsock2.h>
#include	<crtdbg.h>

#include	<string>

using namespace std;

#include	"AboutDialog.h"
#include	"lgFiles.h"
#include	"lgWindows.h"
#include	"rWItalk2.h"


CComModule	_Module;

HWND		hAboutWindow = 0;
ATOM		registeredClassAbout = 0;
HINSTANCE	hInst;

const char* CLASSABOUTWINDOW = "WNDCLASS_ABOUTDIALOG";

void createAboutWindow(HINSTANCE hInstParent, HWND hWndParent)
{
	hInst = hInstParent;
	if (!registeredClassAbout) {
		WNDCLASS	wc;
		wc.lpfnWndProc = WndProcAbout; wc.cbClsExtra = wc.cbWndExtra = 0;
		wc.hInstance = hInstParent; wc.lpszMenuName = NULL; wc.lpszClassName = CLASSABOUTWINDOW;
		wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
		wc.hIcon = LoadIcon(hInstParent, MAKEINTRESOURCE(rIconWItalk2));
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		wc.style = CS_HREDRAW | CS_VREDRAW;
		registeredClassAbout = RegisterClass(&wc);
		_ASSERT(registeredClassAbout);
	}
	RECT	rc;
	GetWindowRect(hWndParent, &rc);
	hAboutWindow = CreateWindowEx(WS_EX_APPWINDOW | WS_EX_CLIENTEDGE, CLASSABOUTWINDOW, lgWindows::LoadString(rStringAboutDialogTitle), WS_CAPTION | WS_SYSMENU | WS_POPUP | WS_VISIBLE,
								  rc.left+16, rc.top+16, 480, 440, hWndParent, NULL, hInstParent, NULL);
	_ASSERT(hAboutWindow);
	ShowWindow(hAboutWindow, SW_SHOW);
	UpdateWindow(hAboutWindow);
}

static void setWindowFontTitle(HWND hwnd)
{
	_ASSERT(hwnd);
	static HFONT	dlgfont = 0;
	if (!dlgfont) {
		dlgfont = CreateFont(24, 0, 0, 0, FW_NORMAL, false, false, false, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
							 ANTIALIASED_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Arial");
	}
	_ASSERT(dlgfont);
	SendMessage(hwnd, WM_SETFONT, (WPARAM)dlgfont, TRUE);
}

static void setWindowFontBody(HWND hwnd)
{
	_ASSERT(hwnd);
	static HFONT	dlgfont = 0;
	if (!dlgfont) {
		dlgfont = CreateFont(16, 0, 0, 0, FW_NORMAL, false, false, false, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
							 ANTIALIASED_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Arial");
	}
	_ASSERT(dlgfont);
	SendMessage(hwnd, WM_SETFONT, (WPARAM)dlgfont, TRUE);
}

static void setWindowFontURL(HWND hwnd)
{
	_ASSERT(hwnd);
	static HFONT	dlgfont = 0;
	if (!dlgfont) {
		dlgfont = CreateFont(16, 0, 0, 0, FW_NORMAL, true, true, false, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
							 ANTIALIASED_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Arial");
	}
	_ASSERT(dlgfont);
	SendMessage(hwnd, WM_SETFONT, (WPARAM)dlgfont, TRUE);
}

LRESULT CALLBACK WndProcAbout(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP	hbitmapWItalk2VLine = 0;

	switch (iMsg) {

	case WM_CREATE: {

		// "WItalk2" rbg}bvpstaticRg[
		CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE | SS_BITMAP, 0, 0, 64, 440, hwnd, (HMENU)1, hInst, NULL);
		if (!hbitmapWItalk2VLine) hbitmapWItalk2VLine = LoadBitmap(hInst, MAKEINTRESOURCE(rWItalk2VLine));
		SendDlgItemMessage(hwnd, 1, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hbitmapWItalk2VLine);

		// "" ACRp static Rg[
		CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE | SS_ICON, 72, 20, 32, 32, hwnd, (HMENU)2, hInst, NULL);
		SendDlgItemMessage(hwnd, 2, STM_SETICON, (WPARAM)LoadIcon(hInst, MAKEINTRESOURCE(rIconWItalk2)), NULL);

		// "WItalk2/Waffle"  static Rg[
		setWindowFontTitle(CreateWindow("STATIC", "WItalk2/Waffle", WS_CHILD | WS_VISIBLE | SS_LEFT, 120, 24, 240, 20, hwnd, (HMENU)3, hInst, NULL));

		// "WItalk2 Website" "TSG Website"  static Rg[
		setWindowFontBody(CreateWindow("STATIC", "WItalk2 Website:", WS_CHILD | WS_VISIBLE | SS_RIGHT, 80, 360, 120, 20, hwnd, (HMENU)4, hInst, NULL));
		setWindowFontBody(CreateWindow("STATIC", "TSG Website:", WS_CHILD | WS_VISIBLE | SS_RIGHT, 80, 380, 120, 20, hwnd, (HMENU)5, hInst, NULL));

		// "http://tsg.jp/~tjkawa/software/witalk2/" "http://www.tsg.ne.jp/"  LINK ǂRg[
		setWindowFontURL(CreateWindow(RICHEDIT_CLASS, "", WS_CHILD | WS_VISIBLE | ES_NOIME | ES_READONLY, 210, 360, 230, 20, hwnd, (HMENU)6, hInst, NULL));
		setWindowFontURL(CreateWindow(RICHEDIT_CLASS, "", WS_CHILD | WS_VISIBLE | ES_NOIME | ES_READONLY, 210, 380, 140, 20, hwnd, (HMENU)7, hInst, NULL));
		SendDlgItemMessage(hwnd, 6, EM_AUTOURLDETECT, TRUE, NULL); SendDlgItemMessage(hwnd, 7, EM_AUTOURLDETECT, TRUE, NULL);
		SETTEXTEX	settextex;
		settextex.codepage = CP_ACP; settextex.flags = ST_DEFAULT;
		SendDlgItemMessage(hwnd, 6, EM_SETTEXTEX, (WPARAM)&settextex, (LPARAM)"http://tsg.jp/~tjkawa/software/witalk2/");
		SendDlgItemMessage(hwnd, 7, EM_SETTEXTEX, (WPARAM)&settextex, (LPARAM)"http://www.tsg.ne.jp/");
		SendDlgItemMessage(hwnd, 6, EM_SETBKGNDCOLOR, (WPARAM)false, (LPARAM)RGB(255, 255, 255));
		SendDlgItemMessage(hwnd, 7, EM_SETBKGNDCOLOR, (WPARAM)false, (LPARAM)RGB(255, 255, 255));

		// WItalk2/Waffle 0.3.1 alpha-6"  static Rg[
		setWindowFontBody(CreateWindow("STATIC", (string(lgWindows::LoadString(rStringWVersion)) + string("   - ") + string(__DATE__) + string(" -")).c_str(),
									   WS_CHILD | WS_VISIBLE | SS_LEFT, 140, 60, 300, 20, hwnd, (HMENU)8, hInst, NULL));

		// Rs[Cg\
		setWindowFontBody(CreateWindowEx(WS_EX_CLIENTEDGE, RICHEDIT_CLASS, "", WS_CHILD | WS_VSCROLL | WS_VISIBLE | ES_AUTOVSCROLL | ES_AUTOHSCROLL | ES_NOIME | ES_READONLY | ES_MULTILINE, 74, 110, 376, 220, hwnd, (HMENU)9, hInst, NULL));
		HRSRC hrsrcWICopy = FindResource(NULL, MAKEINTRESOURCE(rHtmlWItalk2copy), RT_HTML);
		_ASSERT(hrsrcWICopy);
		HGLOBAL hgWICopy = LoadResource(NULL, hrsrcWICopy);
		_ASSERT(hgWICopy);
		char* textWICopy = (char*)LockResource(hgWICopy);
		_ASSERT(textWICopy);
		SendDlgItemMessage(hwnd, 9, EM_SETBKGNDCOLOR, (WPARAM)false, (LPARAM)RGB(255, 255, 255));
		SendDlgItemMessage(hwnd, 9, EM_SETTEXTMODE, TM_RICHTEXT, NULL);
		SendDlgItemMessage(hwnd, 9, EM_SETTEXTEX, (WPARAM)&settextex, (LPARAM)textWICopy);
	
		return 0;
	}

	case WM_SIZE :
		break;

	case WM_CTLCOLORSTATIC:
		return (LONG)GetStockObject(WHITE_BRUSH);
		break;

	case WM_COMMAND:
		if (HIWORD(wParam) == 0x0100 && (LOWORD(wParam) == 6 || LOWORD(wParam) == 7)) {
			char	urlbuf[1024];
			int gwtres = GetWindowText((HWND)lParam, urlbuf, sizeof(urlbuf));
			_ASSERT(gwtres);
			lgFiles::OpenURL(urlbuf, true);
			break;
		}
		break;

	case WM_DESTROY:
		hAboutWindow = 0;
		if (hbitmapWItalk2VLine) { DeleteObject(hbitmapWItalk2VLine); hbitmapWItalk2VLine = 0; }
		return 0;
	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam);
}
