/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// DialogURL.cxx


#include	<winsock2.h>
#include "Dialog.h"
#include "lgDialog.h"
#include "lgFiles.h"
#include "witalk2.h"
#include "profilemanager.h"
#include "WinDLL.h"

extern	WItalk2* witalk2_ptr;
extern	char iniFileName[BUFSIZE];

extern	HWND	firstWindow;

class DialogURL : public lgDialog
{
public:

  static int	url_coloring, url_clicktoopen, url_clickmode, url_execmode, url_bufexecmode;

private:
	ProfileManager* m_pProfileManager;
  /*lgRegistry registry;*/

  int		usecombo;
  int		coloring;
  int		clicktoopen;
  int		clickmode;
  int		execmode;
  int		bufexecmode;

  void set_all(void)
  {
	  // VONbN or _uNbN
	  Button_SetCheck(Hwnd(rRadioURLSingle), !clickmode);
	  Button_SetCheck(Hwnd(rRadioURLDouble), clickmode);

	  // R{{bNX̃uEUN[h
	  Button_SetCheck(Hwnd(rRadioReuseBrowser), !execmode);
	  Button_SetCheck(Hwnd(rRadioNewBrowser), execmode);

	  // Oobt@ォ̃uEUN[h
	  Button_SetCheck(Hwnd(rRadioReuseBrowser2), !bufexecmode);
	  Button_SetCheck(Hwnd(rRadioNewBrowser2), bufexecmode);

	  // URLR{{bNXgpȂȂN[hI grayed
	  EnableWindow(Hwnd(rRadioReuseBrowser), usecombo);
	  EnableWindow(Hwnd(rRadioNewBrowser), usecombo);

	  // URLFEA_[C\ȂȂN[hI grayed
	  EnableWindow(Hwnd(rRadioReuseBrowser2), coloring && clicktoopen);
	  EnableWindow(Hwnd(rRadioNewBrowser2), coloring && clicktoopen);

	  // URLFEA_[C\ݒłNbNŊJݒɂȂĂȂ΃VO/_uI grayed
	  EnableWindow(Hwnd(rRadioURLSingle), clicktoopen && coloring);
	  EnableWindow(Hwnd(rRadioURLDouble), clicktoopen && coloring);

	  // URLFEA_[C\ݒɂȂĂȂ΃NbN[hI grayed
	  EnableWindow(Hwnd(rCheckURLClick), coloring);

	  // URLFEA_[C\`FbN{bNX
	  Button_SetCheck(Hwnd(rCheckURLUnderline), coloring);

	  // URLR{{bNX
	  Button_SetCheck(Hwnd(rCheckUseURLCombo), usecombo);

	  // NbNŊJ
	  Button_SetCheck(Hwnd(rCheckURLClick), clicktoopen);
  }
  
public:
  DialogURL(HWND _hwnd)
    : lgDialog(_hwnd) /*,registry(REGISTRY_ROOT)*/
  { }
  
  // WM_INITDIALOG
  BOOL wmInitDialog(HWND /* focus */, LPARAM  lParam )
  {
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		_ASSERT( m_pProfileManager != NULL );
	// URLꗗR{{bNX
	m_pProfileManager->Read("DoesShowOpenURL", usecombo, true);

	// URLFEA_[C\
	m_pProfileManager->Read("URLColoring", coloring, true);

	// URLNbNĊJ悤ɂ
	m_pProfileManager->Read("URLClickToOpen", clicktoopen, true);

	// NbN[h
	m_pProfileManager->Read("URLClickMode", clickmode, false);

	// R{{bNX̃uEUN[h
	m_pProfileManager->Read("BrowserExecMode", execmode, false);

	// Oobt@ォ̃uEUN[h
	m_pProfileManager->Read("BrowserBufExecMode", bufexecmode, false);

    set_all();
    return TRUE;
  }
  
  // OK ͍XV
  BOOL wmNotify_psnApply(void)
  {
	int		value;

	// URLꗗR{{bNX
	m_pProfileManager->Read("DoesShowOpenURL", value);
	if (value != usecombo) SendMessage(firstWindow, WM_COMMAND, rCommandOtherOpenURL, 0);
	m_pProfileManager->Write("DoesShowOpenURL", Button_GetCheck(Hwnd(rCheckUseURLCombo)));

	// URLFEA_[C\
	m_pProfileManager->Write("URLColoring", Button_GetCheck(Hwnd(rCheckURLUnderline)));

	// URLNbNĊJ悤ɂ
	m_pProfileManager->Write("URLClickToOpen", Button_GetCheck(Hwnd(rCheckURLClick)));

	// VONbN or _uNbN
	m_pProfileManager->Write("URLClickMode", Button_GetCheck(Hwnd(rRadioURLDouble)));

	// R{{bNX̃uEUN[h
	m_pProfileManager->Write("BrowserExecMode", Button_GetCheck(Hwnd(rRadioNewBrowser)));

	// Oobt@ォ̃uEUN[h
	m_pProfileManager->Write("BrowserBufExecMode", Button_GetCheck(Hwnd(rRadioNewBrowser2)));

	// O[oϐɔf
	url_coloring = coloring; url_clicktoopen = clicktoopen; url_clickmode = clickmode; url_execmode = execmode;
	url_bufexecmode = bufexecmode;

    SendMessage(HwndPropertySheetOwner(), WM_DIALOGNOTIFY, rDialogOther, TRUE);
    return lgDialog::wmNotify_psnApply();
  }
  
  // WM_COMMAND
  BOOL wmCommand(int notify_code, int id, HWND /* hwnd_control */)
  {
    switch (id)
    {
#define c(x) case r##x: return wmCommand_##x(notify_code)
#define d(x) case r##x: return wmCommand_common(notify_code)
      c(CheckUseURLCombo);
	  c(CheckURLUnderline);
	  c(CheckURLClick);
	  c(RadioURLSingle);
	  c(RadioURLDouble);
	  c(RadioNewBrowser);
	  c(RadioReuseBrowser);
	  c(RadioNewBrowser2);
	  c(RadioReuseBrowser2);
#undef c
#undef d
    }
    return TRUE;
  }

  // L
  BOOL wmCommand_common(int command)
  {
	  PropertySheetChanged(); set_all(); return TRUE;
  }

  // URLR{{bNX
  BOOL wmCommand_CheckUseURLCombo(int command)
  {
	  PropertySheetChanged(); usecombo = !usecombo; set_all(); return TRUE;
  }

  // URLFEA_[C\
  BOOL wmCommand_CheckURLUnderline(int command)
  {
	  PropertySheetChanged(); coloring = !coloring; set_all(); return TRUE;
  }

  // URLNbNŊJ
  BOOL wmCommand_CheckURLClick(int command)
  {
	  PropertySheetChanged(); clicktoopen = !clicktoopen; set_all(); return TRUE;
  }

  // VONbN
  BOOL wmCommand_RadioURLSingle(int command)
  {
	  PropertySheetChanged(); clickmode = false; set_all(); return TRUE;
  }

  // _uNbN
  BOOL wmCommand_RadioURLDouble(int command)
  {
	  PropertySheetChanged(); clickmode = true; set_all(); return TRUE;
  }

  // R{{bNX̃EBhEėpuEUN
  BOOL wmCommand_RadioReuseBrowser(int command)
  {
	  PropertySheetChanged(); execmode = false; set_all(); return TRUE;
  }
  
  // R{{bNX̐VKEBhEuEUN
  BOOL wmCommand_RadioNewBrowser(int command)
  {
	  PropertySheetChanged(); execmode = true; set_all(); return TRUE;
  }
  
  // Oobt@ォ̃EBhEėpuEUN
  BOOL wmCommand_RadioReuseBrowser2(int command)
  {
	  PropertySheetChanged(); bufexecmode = false; set_all(); return TRUE;
  }
  
  // Oobt@ォ̐VKEBhEuEUN
  BOOL wmCommand_RadioNewBrowser2(int command)
  {
	  PropertySheetChanged(); bufexecmode = true; set_all(); return TRUE;
  }
  

};

int		DialogURL::url_coloring = true;
int		DialogURL::url_clicktoopen = true;
int		DialogURL::url_clickmode = false;
int		DialogURL::url_execmode = false;
int		DialogURL::url_bufexecmode = false;


BOOL CALLBACK DialogURLDlgProc(HWND hwnd, UINT message,
				 WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogURL
  if (!lgwc)
    switch (message)
    {
      lgwmInitDialog;
    }
  else
    switch (message)
    {
      lgwmCommand;
    }
  return lgwc->Default(message, wParam, lParam, TRUE);
}
