/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// ItalkConnection.h


#pragma	once


#include	"lgSocket.h"

#include	<openssl/crypto.h>
#include	<openssl/x509.h>
#include	<openssl/ssl.h>
#include	<openssl/err.h>


class ItalkConnection;


class ItalkConnectionNotify
{
	friend class ItalkConnection;

protected:

	virtual void Connected       (ItalkConnection * ic) = 0;
	virtual void FailedToConnect (ItalkConnection * ic, int wsaerrno) = 0;
	virtual void Disconnected    (ItalkConnection * ic) = 0;
	virtual void ConnectionClosed(ItalkConnection * ic) = 0;
	virtual void Error           (ItalkConnection * ic, int wsaerrno) = 0;
	virtual void DataArrived     (ItalkConnection * ic, const wchar_t *data) = 0;
};


class ItalkConnection : public lgSocket
{
	char *read_buffer;         // ǂݍ݃obt@
	char *read_buffer_reserve; // ǂݍ݃obt@̍őAhX
	char *read_buffer_commit;  // ۂɃ蓖ĂĂ镔
	char *read_pointer;        // ݂ǂ܂œǂݍ񂾂

	ItalkConnectionNotify *icn; //

private:

	BOOL check_read_buffer(void);
	int get_line_length(void);

	void Connected(void);
	void FailedToConnect(int wsaerrno);
	void Disconnected(void);
	void ConnectionClosed(void);
	void Error(int wsaerrno);
	BOOL DataArrived(void);

public:

	bool needAnimationStop;

	ItalkConnection(void);
	~ItalkConnection();

	void SetItalkConnectionNotify(ItalkConnectionNotify *_icn) { icn = _icn; }

	BOOL Disconnect(void) {
		if (IsValid()) Write(L"/q\n");
		return lgSocket::Disconnect();
	}

	BOOL ConnectTo(const char *hostname, u_short port = 12345) {
		return lgSocket::ConnectTo(hostname, port);
	}

	BOOL Write(const wchar_t* str);
	BOOL Write(const char* str);
};
