// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// ItalkInfo.cxx


#include	<winsock2.h>
#include	<crtdbg.h>
#include	"lgcAnimation.h"
#include	"ItalkInfo.h"
#include	"witalk2.h"

#include	<openssl/crypto.h>
#include	<openssl/x509.h>
#include	<openssl/ssl.h>
#include	<openssl/err.h>

#define		USERNO_SHIFT	(0x10000000)

extern		bool is_pairsnow;						// Waffle 0.1.12: Tu[p\tO
extern		bool foundFirstSubroom;					// Waffle 0.1.12a: ŏ̃Tu[ɃOC

extern		int	ViewNormalTelegram, ViewSubroomTelegram, AutoOpenNormalTelegram, AutoOpenSubroomTelegram, DoesAutoLogin, AutoLoginStyle;						// OC` (0 = ftHg̃Tu[̂ / 1 = SẴTu[)

extern		void setPeerTelegramWindowTitle(HWND, ItalkInfo::User*);

extern		int		defSubroomNo;					// ftHg̃Tu[ userno
int			defSubroomNo;

// userno TAȂ΍
int ItalkInfo::search_userno( lgList<User> &users, int userno )
{
	if ( userno < 0 ) return -1;
	for (int i = 0; i < users.Length(); i++) {
		if ( users[i].UserNo() == userno ) {
			return i;
		} else if ( users[i].UserNo() - USERNO_SHIFT == userno ) {
			users[i].UserNo() -= USERNO_SHIFT;
			return i;
		}
	}
	return users.Add(User(userno));
}

ItalkInfo::User* ItalkInfo::search_userno( list<ItalkInfo::User> &users, int userno )
{
	if ( userno < 0 ) return NULL;
	for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ){
		if ( iter->UserNo() == userno ){
			return &(*iter);
		}else if ( iter->UserNo() - USERNO_SHIFT == userno ) {
			iter->UserNo() -= USERNO_SHIFT;
			return &(*iter);
		}
	}
	users.push_back( User(userno) );
	return &(users.back());
}



// ItalkInfoMode ɓ˓
BOOL ItalkInfo::begin_italk_info_mode(void)
{
	info->isInInfo = TRUE;
	info->in_which = in_nowhere;
	info->users.clear();

	for ( list<User>::iterator iter = users.begin(); iter != users.end(); iter++ ) {
		info->users.push_back( *iter );
		info->users.back().UserNo() += USERNO_SHIFT;
	}

	return TRUE;
}




// ItalkInfoMode A
BOOL ItalkInfo::end_italk_info_mode(void)
{
	info->users.remove_if( User::is_userno_ge( USERNO_SHIFT ) );

	// ItalkInfo ɔf
	info->isInInfo = FALSE;
	server = info->server;
	if ( info->my_userno >= 0 ) my_userno = info->my_userno;
	users.clear();

	for( list<User>::iterator iter = info->users.begin() ; iter != info->users.end() ; iter++ ) {
		users.push_back( *iter );
		iter->UserNo() += USERNO_SHIFT;
	}

	return TRUE;
}


// ItalkInfoMode 
BOOL ItalkInfo::parse_italk_info_string(const wchar_t *str)
{
	wchar_t buf[BUFSIZE], *match_end;
	wcscpy(buf, str);

	// \r\n 
	match_end = wcsrchr(buf, L'\r');
	if ( match_end ) *match_end = L'\0';

#define MATCH(match_str) (lgString::DoesMatch(buf, match_str, match_end))

	switch ( info->in_which ) {
	case in_nowhere:
		if      (MATCH(L"</italk>" )) return end_italk_info_mode();
		else if (MATCH(L"<user>"   )) info->in_which = in_user,info->temp_user.Init();
		else if (MATCH(L"<you>"    )) info->in_which = in_you;
		else if (MATCH(L"<server>" )) info->in_which = in_server;
		break;
	case in_user:
		if (MATCH(L"</user>")) {
			//int i = search_userno(info->users, info->temp_user.UserNo());
			//if ( i >= 0 ) info->users[i] = info->temp_user;
			User* pu = search_userno(info->users, info->temp_user.UserNo());
			if( pu ) *pu = info->temp_user;
			info->in_which = in_nowhere;
			if (info->server.subrooms) witalk2_ptr->servercaps_subroom = true;	// Waffle 0.2.0f

			if (!foundFirstSubroom && info->temp_user.userno >= 9900 /*wcscmp(info->temp_user.clientType, L"subroom") == 0*/ && !defSubroomNo) defSubroomNo = info->temp_user.userno;		// Waffle 0.2.0e: ftHgTu[ userno L^  // Waffle 0.2.0f
			/* Waffle 0.2.0: ŏɌ subroom Ȃ烍OC */
			if ((DoesAutoLogin) && ((AutoLoginStyle == 0 && info->server.subrooms && !foundFirstSubroom) || AutoLoginStyle == 1)){
				/* type=subroom łȂΈʃ[U */
				if (witalk2_ptr->servercaps_subroom && info->temp_user.userno >= 9900/*wcscmp(info->temp_user.clientType, L"subroom") == 0*/){
					wchar_t	sendstr[1024];
					swprintf(sendstr, L"/p %d /login\r\n", info->temp_user.userno);
					witalk2_ptr->send_str(sendstr);
					foundFirstSubroom = true;
				}
			}

			/* ʓdEBhEJĂꍇ͔f */
			HWND	hwnd = witalk2_ptr->SearchTelegramDeliveryTable(info->temp_user.userno);
			if (hwnd) setPeerTelegramWindowTitle(hwnd, &info->temp_user);

		}
		else if (MATCH(L"userno="   )) info->temp_user.UserNo() = _wtoi(match_end);
		else if (MATCH(L"uptime="   )) info->temp_user.UpTime() = _wtoi(match_end);
		else if (MATCH(L"idle="     )) info->temp_user.Idle  () = _wtoi(match_end);
		else if (MATCH(L"handle="   )) info->temp_user.Handle   (match_end);
		else if (MATCH(L"host="     )) info->temp_user.Host     (match_end);
		else if (MATCH(L"status="   )) info->temp_user.Status   (match_end);
		else if (MATCH(L"downcode=" )) info->temp_user.Downcode (match_end);
		else if (MATCH(L"logintime=")) info->temp_user.Logintime() = (time_t)_wtoi64(match_end);
		// Waffle 0.2.0f: else if (MATCH(L"type="    )) info->temp_user.ClientType(match_end);
		break;
	case in_you:
		if      (MATCH(L"</you>"   )) info->in_which = in_nowhere;
		else if (MATCH(L"userno="  )) info->my_userno = _wtoi(match_end);
		break;
	case in_server:
		if      (MATCH(L"</server>")) info->in_which = in_nowhere;
		else if (MATCH(L"host="    )) info->server.Host(match_end);
		else if (MATCH(L"port="    )) info->server.Port() =  (u_short)_wtoi(match_end);
		else if (MATCH(L"users="   )) info->server.Users()          = _wtoi(match_end);
		else if (MATCH(L"boottime=")) info->server.BootTime()       = _wtoi(match_end);
		else if (MATCH(L"currenttime=")) info->server.CurrentTime() = _wtoi(match_end);
		else if (MATCH(L"uptime="  )) info->server.UpTime()         = _wtoi(match_end);
		else if (MATCH(L"logcode=" )) info->server.LogCode(match_end);
		else if (MATCH(L"announce=")) info->server.Announce(match_end);
		else if (MATCH(L"subrooms=")) info->server.SubRoom()        = _wtoi(match_end);		/* Tu[F */
		else if (MATCH(L"version=" )) {
			if (wcsncmp(match_end, L"inid ", 5) == 0) server.is_inid = true;
		}
		break;
	}
	return TRUE;
}

// newuser 
BOOL ItalkInfo::parse_newuser_string(const wchar_t *str)
{
	wchar_t buf[BUFSIZE], *match_end;
	wcscpy(buf, str);

	// \r\n 
	match_end = wcsrchr(buf, L'\r');
	if ( match_end ) *match_end = L'\0';

#define MATCH(match_str) (lgString::DoesMatch(buf, match_str, match_end))

	if (MATCH(L"</newuser>")) {
		users.push_back( info->temp_user );
		server.Users() += 1;
		info->isInNewUser = FALSE;
	}
	else if (MATCH(L"userno="  ))	info->temp_user.UserNo() = _wtoi(match_end);
	else if (MATCH(L"uptime="  ))	info->temp_user.UpTime() = _wtoi(match_end);
	else if (MATCH(L"idle="    ))	info->temp_user.Idle  () = _wtoi(match_end);
	else if (MATCH(L"handle="  ))	info->temp_user.Handle		(match_end);
	else if (MATCH(L"host="    ))	info->temp_user.Host		(match_end);
	else if (MATCH(L"status="  ))	info->temp_user.Status		(match_end);
	else if (MATCH(L"downcode="))	info->temp_user.Downcode	(match_end);
	else if (MATCH(L"logintime="))	info->temp_user.Logintime() = (time_t)_wtoi64(match_end);
	return TRUE;
}


// sXe[^X
BOOL ItalkInfo::parse_one_line(const wchar_t *str)
{
	int userno;
	wchar_t buf[BUFSIZE], *match_end;
	wcscpy(buf, str);

	// \r\n 
	match_end = wcsrchr(buf, L'\r');
	if ( match_end ) *match_end = L'\0';

	if ( !wcsncmp(buf, L"newhandle=", 10) ) {
		userno = _wtoi(buf+10);
		match_end = wcschr(buf+10, L',');
		if ( match_end ) {
			match_end++;

			for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ) {
				if ( iter->UserNo() == userno ) {
					iter->Handle(match_end);
					// Waffle 0.2.0d: ʃEBhẼ^CgXV
					HWND hwnd = witalk2_ptr->SearchTelegramDeliveryTable(userno);
					if (hwnd){
						setPeerTelegramWindowTitle(hwnd, &(*iter));
					}
					break;
				}
			}
		}
	} else if ( !wcsncmp(buf, L"newstatus=", 10) ) {
		userno = _wtoi(buf+10);
		match_end = wcschr(buf+10, L',');
		if ( match_end ) {
			match_end++;
			for (list<User>::iterator iter = users.begin(); iter != users.end(); iter++) if ( iter->UserNo() == userno ) {
				iter->Status(match_end);
				// Waffle 0.2.0b: ʃEBhẼ^CgXV
				HWND hwnd = witalk2_ptr->SearchTelegramDeliveryTable(userno);
				if (hwnd){
					setPeerTelegramWindowTitle(hwnd, &(*iter));
				}
				break;
			}
		}
	} else if ( !wcsncmp(buf, L"logout=", 7) ) {
		userno = _wtoi(buf+7);
		for ( std::list<User>::iterator iter = users.begin(); iter != users.end(); iter++) if ( iter->UserNo() == userno ) {
			users.erase( iter );
			server.Users() -= 1;
			AQT(("userno %u deleted.\n", userno));
			// Waffle 0.2.0d: ʃEBhE "******** logout ********" ǉ
			HWND hwnd = witalk2_ptr->SearchTelegramDeliveryTable(userno);
			if (hwnd){
				SendMessage(hwnd, WM_COMMAND, rCommandAppendLog, (LPARAM)lgWindows::LoadStringW(rStringApndLoggedOut));
			}
			break;
		}
	} else if ( !wcsncmp(buf, L"disconnect=", 11) ) {
		userno = _wtoi(buf+11);
		for (list<User>::iterator iter = users.begin(); iter != users.end() ; iter++) if ( iter->UserNo() == userno ) {
			users.erase( iter );
			server.Users() -= 1;
			// Waffle 0.2.0d: ʃEBhE "******** disconnect ********" ǉ
			HWND hwnd = witalk2_ptr->SearchTelegramDeliveryTable(userno);
			if (hwnd){
				SendMessage(hwnd, WM_COMMAND, rCommandAppendLog, (LPARAM)lgWindows::LoadStringW(rStringApndDisconnected));
			}
			break;
		}
	} else if ( !wcsncmp(buf, L"negotiation=ssl,start", 21) ) {
		// SSLڑAj[V
	    lgcAnimation_Start(witalk2_ptr->hwnd_anim_connectto, 100);
		witalk2_ptr->ic.needAnimationStop = true;
		// SSLڑJn
		witalk2_ptr->ic.ctx = SSL_CTX_new(SSLv3_client_method());
		if (!witalk2_ptr->ic.ctx) {
			MessageBox(0, lgWindows::LoadString(rStringErrorSSL_CTX_new), lgWindows::TheName(), MB_OK); goto ssl_exit;
		}
		witalk2_ptr->ic.ssl = SSL_new(witalk2_ptr->ic.ctx);
		if (!witalk2_ptr->ic.ssl) {
			MessageBox(0, lgWindows::LoadString(rStringErrorSSL_new), lgWindows::TheName(), MB_OK); goto ssl_exit;
		}
		if (!SSL_set_fd(witalk2_ptr->ic.ssl, witalk2_ptr->ic.getSocket())) {
			MessageBox(0, lgWindows::LoadString(rStringErrorSSL_set_fd), lgWindows::TheName(), MB_OK); goto ssl_exit;
		}
		switch (SSL_get_error(witalk2_ptr->ic.ssl, SSL_connect(witalk2_ptr->ic.ssl))) {
		case SSL_ERROR_WANT_READ: case SSL_ERROR_WANT_WRITE:
			/* ׂƂł SSL_ERROR_WANT_READ K͂CłȂɂ̋Ƃ (MessageBox) 
			   SSLڑmɎsBSleep 񂾂肵Ă߁BԂ̂busy loopł߁B\PbgʐM̃^C~O肩ȂB */
			//MessageBox(0, "SSL_ERROR_WANT_SOMETHING", lgWindows::TheName(), MB_OK);
			//for (unsigned int i = 100/*4294967295/8*/; i != 0; i--) ;
			break;
		case SSL_ERROR_NONE:
			break;
		default:
			break;
		}
		witalk2_ptr->ic.sslMode = true;
ssl_exit:
		return -1;
#if 0			// "#! "Ŏn܂s͖ɓǂݎ̂Ă(̃T[ogւ̑΍)
	} else {
		return FALSE;
#endif
	}
	return TRUE;
}

ItalkInfo::ItalkInfo(void)
{
	info = NULL;
	my_userno = -1;
}


// ItalkInfoMode ̕񂩂ǂ`FbN
int ItalkInfo::Check(const wchar_t *str, BOOL isMain )
{
	// modified by TYM - [ǂ݂ɂ
	info = (isMain) ? &infoMain : &infoBiff;
	if ( str[0] == L'(' || (str[0] == L'#' && str[1] != L'!') ) {
		if ( info->isInInfo ) end_italk_info_mode();
		if ( info->isInNewUser ) info->isInNewUser = FALSE;
		return FALSE;
	}

	if ( str[0] == L'#' && str[1] == L'!' && str[2] == L' ' ) {
		if ( info->isInInfo ) return parse_italk_info_string(str+3);
		else if ( info->isInNewUser ) return parse_newuser_string(str+3);
		else if ( !wcsncmp(str, L"#! <italk>", 10) ) return begin_italk_info_mode();
		else if ( !wcsncmp(str, L"#! <newuser>", 12) ) return info->temp_user.Init(), info->isInNewUser = TRUE;
		else return parse_one_line(str+3);
	} else if ( str[0] != L'#' && str[0] != '(' ) {
		if ( info->isInInfo ) return parse_italk_info_string(str);
		else if ( !wcsncmp(str, L"<italk>", 7) ) return begin_italk_info_mode();
	}

	return FALSE;
}


// fobOp
// TODO : sizeof_buf
wchar_t *ItalkInfo::GetUsersStringForDebug(int i, wchar_t *buf, int sizeof_buf)
{
	User* pu = NULL;
	int c = 0;
	for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ){
		if( c == i ){
			pu = &(*iter);
			break;
		}
		c++;
	}
	if ( !pu ) return NULL;
	swprintf(buf, L"#debug (%04d) %s@%s <%s>\r\n",
		pu->UserNo() - (pu->UserNo() < USERNO_SHIFT ? 0 : USERNO_SHIFT),
		pu->Handle() ? pu->Handle() : L"",
		pu->Host  () ? pu->Host  () : L"",
		pu->Status() ? pu->Status() : L"");
	return buf;
}


// Zbg
void ItalkInfo::Reset(void)
{
	infoMain.isInInfo = infoMain.isInNewUser = FALSE;
	infoBiff.isInInfo = infoBiff.isInNewUser = FALSE;
	my_userno = -1;
	users.clear();
}


// ̃[U[ԍ𓾂
int ItalkInfo::GetNextUserNo(int userno)
{
	if (users.empty()) return -1;

	for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ){
	
		if (iter->UserNo() == userno ||
			iter->UserNo() == userno + USERNO_SHIFT)
		{
			iter++;
			if( iter == users.end() )
				iter = users.begin();

			return iter->UserNo() % USERNO_SHIFT;
		}
	}
	return users.front().UserNo() % USERNO_SHIFT;
}


// Õ[U[ԍ𓾂
int ItalkInfo::GetPrevUserNo(int userno)
{
	if (users.empty()) return -1;

	for( list<User>::reverse_iterator iter = users.rbegin() ; iter != users.rend() ; iter++ ){
	
		if (iter->UserNo() == userno ||
			iter->UserNo() == userno + USERNO_SHIFT)
		{
			iter++;
			if( iter == users.rend() )
				iter = users.rbegin();

			return iter->UserNo() % USERNO_SHIFT;
		}
	}
	return users.front().UserNo() % USERNO_SHIFT;
}


// [U[ԍ𓾂
int ItalkInfo::GetRightUserNo(int userno)
{
	if (users.empty() ) return -1;

	for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ){
	
		if (iter->UserNo() == userno ||
			iter->UserNo() == userno + USERNO_SHIFT)
		{
			return iter->UserNo() % USERNO_SHIFT;
		}
	}
	return users.front().UserNo() % USERNO_SHIFT;
}


// [U[ԍnh𓾂
const wchar_t *ItalkInfo::GetHandle(int userno)
{
	User *user = GetUser(userno);
	if (user) return user->Handle();
	else      return NULL;
}


// 擪ɎĂ
void ItalkInfo::Raise(int userno)
{
	if (users.empty()) return;
	if (0 <= userno){
		for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ){
			if (iter->UserNo() == userno ||
				iter->UserNo() == userno + USERNO_SHIFT)
			{
				users.push_front( *iter );		
				users.erase( iter );
				break;
			}
		}
	}
}


// ItalkInfoMode ǂ
BOOL ItalkInfo::IsInItalkInfoMode(void)
{
	return infoMain.isInInfo || infoMain.isInNewUser || infoBiff.isInInfo || infoBiff.isInNewUser;
}


// [U[ԍ烆[U[𓾂
ItalkInfo::User *ItalkInfo::GetUser(int userno)
{
	if (users.empty()) return NULL;
	if (0 <= userno){
		for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ){
			if (iter->UserNo() == userno ||
				iter->UserNo() == userno + USERNO_SHIFT)
			{
				return &(*iter);
	
			}
		}
	}
	return NULL;

}


// CfbNXԍ烆[U[𓾂
ItalkInfo::User *ItalkInfo::GetUserFromIndex(int index)
{
	User* pu = NULL;
	int c = 0;
	for( list<User>::iterator iter = users.begin() ; iter != users.end() ; iter++ ){
		if( c == index ){
			pu = &(*iter);
			break;
		}
		c++;
	}
	return pu;
}


// italk server ̏𓾂
ItalkInfo::Server *ItalkInfo::GetServer(void)
{
	return &server;
}


// ̃[U[ԍԂ
int ItalkInfo::WhoAmI(void)
{
	return my_userno;
}


ItalkInfo &ItalkInfo::operator=(const ItalkInfo &other)
{
	if ( other.my_userno >= 0 ) my_userno = other.my_userno;
	if ( this != &other ) {
		server = other.server;
		infoMain = other.infoMain;
		infoBiff = other.infoBiff;
		info = other.info;
	}
	users = other.users;
	return *this;
}
