/*
 * SimpleMutex - Ȉ Mutex NX
 * Copyright (c) 2002 by Project Waffle / TSUJIKAWA Tohru <tsujikawa@tsg.ne.jp>
 *  
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// SimpleMutex.h

#pragma	once

#include	<windows.h>
#include	<crtdbg.h>


//
// Ȉ Mutex NX
//
class SimpleMutex {

	HANDLE	mutex;

public:

	SimpleMutex() {
		mutex = CreateMutex(NULL, FALSE, NULL);
		_ASSERT(mutex);
	}

	~SimpleMutex() {
		if (mutex) CloseHandle(mutex);
	}

	void lock() {
		WaitForSingleObject(mutex, INFINITE);
	}

	void unlock() {
		ReleaseMutex(mutex);
	}

};

//
// Mutex  lock/unlock NX
//
class AutoMutex {

	SimpleMutex*	mutex;

public:

	AutoMutex(SimpleMutex* _mutex) { mutex = _mutex; mutex->lock(); }
	~AutoMutex() { mutex->unlock(); }

};
