/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// TelegramWindow.cpp

#include	<winsock2.h>
#include	<crtdbg.h>

#include	<windows.h>

#include	<stdio.h>
#include	<stdlib.h>

#include	<string>
using namespace std;

#include	"WItalk2.h"
#include	"lgDialog.h"
#include	"rWItalk2.h"
#include	"resource.h"
#include	"lgFiles.h"
#include	"DialogURL.h"
#include    "profilemanager.h"
#include	"WinDLL.h"
#include	"TrapFocus.h"

int		telegramWindowClose = false;

int		ViewNormalTelegram;					// ʏdʃEBhEɔzĂEBhEɕ\邩
int		ViewSubroomTelegram;				// Tu[OʃEBhEɔzĂEBhEɕ\邩
int		AutoOpenNormalTelegram;				// ʏd񓞒ɂĎIɌʃEBhEJ
int		AutoOpenSubroomTelegram;			// Tu[OɂĎIɌʃEBhEJ
int		DoesAutoLogin;						// Tu[ɎOC邩
int		AutoLoginStyle;						// OC` (0 = ftHg̃Tu[̂ / 1 = SẴTu[)
int		DoesAutoLogout;						// Tu[ʃEBhEɎOAEg邩

class staticInitializer{
public:
	void initialize(){
		if( witalk2_ptr ){
			ProfileManager* pManager = witalk2_ptr->getProfileManager();
			
			pManager->Read("ViewNormalTelegram", ViewNormalTelegram, true);
			ViewSubroomTelegram = false; //pManager->Read("ViewSubroomTelegram", ViewSubroomTelegram, false);
			pManager->Read("AutoOpenNormalTelegram", AutoOpenNormalTelegram, true);
			AutoOpenSubroomTelegram = true; //pManager->Read("AutoOpenSubroomTelegram", AutoOpenSubroomTelegram, true);
			pManager->Read("DoesAutoLogin", DoesAutoLogin, true);
			pManager->Read("AutoLoginStyle", AutoLoginStyle, 0);
			pManager->Read("DoesAutoLogout", DoesAutoLogout, 0);
		}else{
			lgRegistry	reg(REGISTRY_ROOT);

			reg.Read("ViewNormalTelegram", ViewNormalTelegram, true);
			ViewSubroomTelegram = false; //reg.Read("ViewSubroomTelegram", ViewSubroomTelegram, false);
			reg.Read("AutoOpenNormalTelegram", AutoOpenNormalTelegram, true);
			AutoOpenSubroomTelegram = true; //reg.Read("AutoOpenSubroomTelegram", AutoOpenSubroomTelegram, true);
			reg.Read("DoesAutoLogin", DoesAutoLogin, true);
			reg.Read("AutoLoginStyle", AutoLoginStyle, 0);
			reg.Read("DoesAutoLogout", DoesAutoLogout, 0);
		}
	}
	void save(){
		if( witalk2_ptr ){
			ProfileManager* pManager = witalk2_ptr->getProfileManager();
			
			pManager->Write("ViewNormalTelegram", ViewNormalTelegram);
			pManager->Write("ViewSubroomTelegram", ViewSubroomTelegram);
			pManager->Write("AutoOpenNormalTelegram", AutoOpenNormalTelegram);
			pManager->Write("AutoOpenSubroomTelegram", AutoOpenSubroomTelegram);
			pManager->Write("DoesAutoLogin", DoesAutoLogin);
			pManager->Write("AutoLoginStyle", AutoLoginStyle);
			pManager->Write("DoesAutoLogout", DoesAutoLogout);
		}else{	
			lgRegistry	reg(REGISTRY_ROOT);

			reg.Write("ViewNormalTelegram", ViewNormalTelegram);
			reg.Write("ViewSubroomTelegram", ViewSubroomTelegram);
			reg.Write("AutoOpenNormalTelegram", AutoOpenNormalTelegram);
			reg.Write("AutoOpenSubroomTelegram", AutoOpenSubroomTelegram);
			reg.Write("DoesAutoLogin", DoesAutoLogin);
			reg.Write("AutoLoginStyle", AutoLoginStyle);
			reg.Write("DoesAutoLogout", DoesAutoLogout);
		}
	}
	staticInitializer(){
		initialize(); save();
	}
} dmy;

// EBhEf[^ ========================================================
class TelegramWndProcData : public ReSubClass {

public:

	int				userno;					// ʐMΏۂ userno
	string			hostname;				// ʐMΏۂ T[o
	USHORT			port;					// ʐMΏۂ |[gԍ
	ItalkView*		iv_input;				// ̓obt@
	ItalkView*		iv_log_private;			// Oobt@
	HWND			splitbar;				// Xvbgo[ HWND
	bool			completedFirstResize;	// ŏ̃TCYς񂾂
	bool			inFocus;				// tH[JXĂ邩
	bool			inFocus_iv_input;		// iv_input ɃtH[JXĂ邩
	bool			inFocus_iv_log_private;	// iv_log_private ɃtH[JXĂ邩
	WNDPROC			oldWndProcInput;		// iv_input EBhEvV[Wւ̃|C^
	WNDPROC			oldWndProcLogPrivate;	// iv_log_private EBhEvV[Wւ̃|C^
	bool			doesAutoScroll;			// I[gXN[邩ۂ
	bool			inBacklog;				// obNO
	int				spllayout;				// Xvbgo[̃CAEg
	bool			spllayout_valid;		// spllayout Lۂ
	int				splbarplace;			// Xvbgo[̕ʒu
	bool			splbarplace_valid;		// splbarplace Lۂ

	TelegramWndProcData(){
		iv_input = 0; iv_log_private = 0; completedFirstResize = false;
		inFocus = inFocus_iv_input = inFocus_iv_log_private = false;
		doesAutoScroll = true; inBacklog = false;
		spllayout_valid = false; splbarplace_valid = false;
	}
	~TelegramWndProcData(){
		if (iv_input != 0) delete iv_input;
		if (iv_log_private != 0) delete iv_log_private;
	}

};

// ݃ANeBu ItalkView Ԃ
static ItalkView* iv_get_focused_only_telegram(TelegramWndProcData* twpd)
{
	if (twpd->inFocus_iv_input) return twpd->iv_input;
	if (twpd->inFocus_iv_log_private) return twpd->iv_log_private;
	return 0;
	
}
static ItalkView* iv_get_focused_telegram(TelegramWndProcData* twpd)
{
	if (twpd->inFocus_iv_input) return twpd->iv_input;
	if (twpd->inFocus_iv_log_private) return twpd->iv_log_private;
	return twpd->iv_input;
}

// ENbNj[o ===================================================
static void popupRbuttonmenuTelegram(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	HMENU&	hPopupMenu = witalk2_ptr->hPopupMenu;
	POINT	point;
	TelegramWndProcData* twpd = (TelegramWndProcData*)GetWindowLongPtr(GetParent(GetParent(hwnd)), GWLP_USERDATA/*0*/);

	point.x = LOWORD(lParam), point.y = HIWORD(lParam);
	ClientToScreen(hwnd, &point);

	// ÕI[gXN[̃`FbN
	CheckMenuItem(hPopupMenu, rCommandLogAutoScroll, ((twpd->doesAutoScroll) ? (MF_CHECKED) : (0)) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandLogAutoScroll, MF_ENABLED | MF_BYCOMMAND);

	// [UꗗEBhẼ`FbN
	EnableMenuItem(hPopupMenu, rCommandOtherUsers, MF_GRAYED | MF_BYCOMMAND);
	CheckMenuItem(hPopupMenu, rCommandOtherUsers, (witalk2_ptr->menu.IsChecked(rCommandOtherUsers) ? MF_CHECKED : 0) | MF_BYCOMMAND);

	EnableMenuItem(hPopupMenu, rCommandClearBuffer, MF_ENABLED | MF_BYCOMMAND);

	bool	clipext = IsClipboardFormatAvailable(CF_TEXT) || IsClipboardFormatAvailable(CF_OEMTEXT) || IsClipboardFormatAvailable(CF_UNICODETEXT);
	EnableMenuItem(hPopupMenu, rCommandEditPaste, (clipext ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandEditQuotedPaste, (clipext ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	bool	bufselected = !!(iv_get_focused_telegram(twpd)->Re.IsSelected());
	bool	bufwritable = !iv_get_focused_only_telegram(twpd)->Re.GetReadOnly();
	EnableMenuItem(hPopupMenu, rCommandEditCopy, (bufselected ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandEditCut, ((bufselected && bufwritable) ? MF_ENABLED : MF_GRAYED)| MF_BYCOMMAND);

	bool	selsend = bufselected && witalk2_ptr->isConnectionActive;
	EnableMenuItem(hPopupMenu, rCommandEditSendToItalk, (selsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	bool	clipsend = clipext && witalk2_ptr->isConnectionActive;
	EnableMenuItem(hPopupMenu, rCommandEditPasteSendToItalk, (clipsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(hPopupMenu, rCommandEditQuotedPasteSendToItalk, (clipsend ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);

	// Waffle 0.2.2beta6: Ŝߑ΍
	SetForegroundWindow(hwnd);
	TrackPopupMenu(hPopupMenu, 0, point.x, point.y, 0, GetParent(GetParent(hwnd)), NULL);
	PostMessage(hwnd, WM_NULL, 0, 0);

	return;
}

// ̓obt@TuNX =================================================
//
//   EBhEłATuNXȂ WM_RBUTTONDOWN Ƃ
//   bZ[WłȂB
//
LRESULT CALLBACK TrapTelegramWindowInput(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	// b`GfBbg̐e splitbar ł̂܂eʓdEBhE
	TelegramWndProcData*	twpd = (TelegramWndProcData*)GetWindowLongPtr(GetParent(GetParent(hwnd)), GWLP_USERDATA/*0*/);

	switch(iMsg){
	case WM_KEYDOWN:
		{
			POINT	caretPos;
			if (wParam != 0x5D || lParam != 0x15D0001) break;
			if (GetCaretPos(&caretPos) == 0) break;
			lParam = (caretPos.y & 0xFFFF) << 16 | (caretPos.x & 0xFFFF);
		}
	case WM_RBUTTONDOWN:
		popupRbuttonmenuTelegram(hwnd, wParam, lParam);
		return 0;
	case WM_SETFOCUS:
		AQT(("TelegramInput SETFOCUS %.8X\n", hwnd));
		if (lParam != 0x4624 && lParam != 0x4624*2) twpd->inFocus_iv_input = true;
		break;
	case WM_KILLFOCUS:
		AQT(("TelegramInput KILLFOCUS %.8X\n", hwnd));
		if (lParam != 0x4624 && lParam != 0x4624*2) twpd->inFocus_iv_input = false;
		break;
	}
	return CallWindowProc(twpd->oldWndProcInput, hwnd, iMsg, wParam, lParam);
}

// Oobt@TuNX =================================================
//
LRESULT CALLBACK TrapTelegramWindowLogPrivate(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	// b`GfBbg̐e splitbar ł̂܂eʓdEBhE
	TelegramWndProcData*	twpd = (TelegramWndProcData*)GetWindowLongPtr(GetParent(GetParent(hwnd)), GWLP_USERDATA /*0*/);

	switch(iMsg){
	case WM_KEYDOWN:
		{
			POINT	caretPos;
			if (wParam != 0x5D || lParam != 0x15D0001) break;
			if (GetCaretPos(&caretPos) == 0) break;
			lParam = (caretPos.y & 0xFFFF) << 16 | (caretPos.x & 0xFFFF);
		}
	case WM_RBUTTONDOWN:
		popupRbuttonmenuTelegram(hwnd, wParam, lParam);
		return 0;
	case WM_SETFOCUS:
		AQT(("TelegramLog SETFOCUS %.8X\n", hwnd));
		if (lParam != ReSubClass::focusMagicNo && lParam != ReSubClass::focusMagicNo*2) {
			twpd->inFocus_iv_log_private = true;
			wfocusStatus.setFocus(hwnd);
		}
		break;
	case WM_KILLFOCUS:
		AQT(("TelegramLog KILLFOCUS %.8X\n", hwnd));
		if (lParam != ReSubClass::focusMagicNo && lParam != ReSubClass::focusMagicNo*2) {
			twpd->inFocus_iv_log_private = false;
			wfocusStatus.killFocus(hwnd);
		}
		break;
	}
	return CallWindowProc(twpd->oldWndProcLogPrivate, hwnd, iMsg, wParam, lParam);
}

// w肳ꂽʃEBhẼ^Cgݒ ===================================
void setPeerTelegramWindowTitle(HWND hwnd, ItalkInfo::User* user)
{
	ItalkInfo::Server* server = &witalk2_ptr->italk_info.server;
	char	serverName[BUFSIZE];
	strcpy(serverName, witalk2_ptr->getItalkHost() /* server->host.c_str() */);
	SendMessage(hwnd, WM_COMMAND, rCommandSetServername, (LPARAM)serverName);
	SendMessage(hwnd, WM_COMMAND, rCommandSetServerport, (LPARAM)server->port);
	{ for (char *p = serverName; *p != 0; p++) if (*p == '.') *p = 0; }
	if (user == NULL) {
		TelegramWndProcData* twpd = (TelegramWndProcData*)GetWindowLongPtr(hwnd, GWLP_USERDATA/*0*/);
		if (twpd->userno >= 9900) {	// inid quickhack
			char	threadtitle[BUFSIZE];
			sprintf(threadtitle, "Thread <%d> - %s:%d", 10000-twpd->userno, serverName, server->port);
			SetWindowText(hwnd, threadtitle);
			return;
		}
		return;
	}
	char	handle[BUFSIZE], status[BUFSIZE];
	wcstombs(handle, user->handle.c_str(), sizeof(handle)); 
	if ( !user->status.empty() ) wcstombs(status, user->status.c_str(), sizeof(status));

	char	winTitle[BUFSIZE];
	if (witalk2_ptr->servercaps_subroom && user->userno >= 9900){		// Tu[
		if ( !user->status.empty() ){
			if (server->port != 12345) sprintf(winTitle, "[%s] <%s> (%.4d) - %s:%d", handle, status, user->userno, serverName, server->port);
			else sprintf(winTitle, "[%s] <%s> (%.4d) - %s", handle, status, user->userno, serverName);
		} else {
			if (server->port != 12345) sprintf(winTitle, "[%s] (%.4d) - %s:%d", handle, user->userno, serverName, server->port);
			else sprintf(winTitle, "[%s] (%.4d) - %s", handle, user->userno, serverName);
		}
	} else {										// l
		if ( !user->status.empty()){
			if (server->port != 12345) sprintf(winTitle, "[%s] (%.4d) - %s:%d <%s>", handle, user->userno, serverName, server->port, status);
			else sprintf(winTitle, "[%s] (%.4d) - %s <%s>", handle, user->userno, serverName, status);
		} else {
			if (server->port != 12345) sprintf(winTitle, "[%s] (%.4d) - %s:%d", handle, user->userno, serverName, server->port);
			else sprintf(winTitle, "[%s] (%.4d) - %s", handle, user->userno, serverName);
		}
	}
	SetWindowText(hwnd, winTitle);
	return;
}

// EBhEvV[W =====================================================
//
//   gEBhE (cbWndExtra) gp󋵂͈ȉ̂Ƃ:
//
//     0000: (DWORD) f[^̈ւ̃|C^
//
LRESULT CALLBACK TelegramWndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	TelegramWndProcData* twpd = (TelegramWndProcData*)GetWindowLongPtr(hwnd, GWLP_USERDATA/*0*/);
	_ASSERT(twpd != (TelegramWndProcData*)0xcccccccc);
	switch(iMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case rCommandAppendLog:		/* Xbh烍Oǉv */
			{
				wchar_t*	buf = (wchar_t*)lParam;
				int			len = wcslen(buf);
				/* obNÕI[gXN[ */
				if (len >= 42){
					if (wcsncmp(buf, L"## __ BACK LOG START _____________________", 42) == 0){
						//lgRegistry	reg(REGISTRY_ROOT);
						ProfileManager* pManager = witalk2_ptr->getProfileManager();
						int			NonStopAutoScrollInBacklog;
						pManager->Read("NonStopAutoScrollInBacklog", NonStopAutoScrollInBacklog, false);
						if (NonStopAutoScrollInBacklog) twpd->inBacklog = false; else twpd->inBacklog = true;
					} else if (wcsncmp(buf, L"## -- BACK LOG END -----------------------", 42) == 0){
						twpd->inBacklog = false;					
					}
				}
				/* Oobt@ɒǉ */
				twpd->iv_log_private->AddText(buf, twpd->doesAutoScroll && (!twpd->inBacklog));
				return 0;
			}
		case rCommandClearBuffer:			// obt@NA
			{
				if (MessageBox(hwnd, lgWindows::LoadString(rStringQuestionClearBuffer), lgWindows::TheName(), MB_OKCANCEL | MB_ICONQUESTION | MB_DEFBUTTON2) == IDOK) {
					twpd->iv_log_private->Re.clearBuffer();
				}
				return 0;
			}
		case rCommandClearClipboard:		// Nbv{[hNA
			{
				witalk2_ptr->wmCommand_ClearClipboard();
				return 0;
			}
		case rCommandToggleFreeEdit:		// RҏW[hgO
			{
				witalk2_ptr->wmCommand_ToggleFreeEdit();
				return 0;
			}
		case rCommandSetSpllayout:	/* Xvbgo[̏Ԃ󂯎*/
			{
				twpd->spllayout = lParam; twpd->spllayout_valid = true;
				return 0;
			}
		case rCommandSetSplbarplace:/* Xvbgo[̕ʒuݒ󂯎 */
			{
				twpd->splbarplace = lParam; twpd->splbarplace_valid = true;
				return 0;
			}
		case rCommandSetServername:	/* ʐMΏۂ T[oʒm */
			{
				twpd->hostname.assign((char*)lParam);
				return 0;
			}
		case rCommandSetServerport:	/* ʐMΏۂ |[gԍʒm */
			{
				twpd->port = (USHORT)lParam;
				return 0;
			}
		case rCommandSetUid:		/* ʐMΏۂ userno ʒm */
			{
				/* userno ۑ */
				twpd->userno = lParam;
				/* dze[uɓo^ */
				witalk2_ptr->RegisterTelegramDeliveryTable(twpd->userno, hwnd);
				/* ۂƂ݂̂ŏbZ[WĂ */
				wchar_t		initMsg[1024];
				if (twpd->userno >= 9900) swprintf(initMsg, L"# Subroom log window (userno = %d)\r\n", twpd->userno);
				else swprintf(initMsg, L"# Peer-to-peer telegram window (userno = %d)\r\n", twpd->userno);
				twpd->iv_log_private->AddText(initMsg, TRUE);
				return 0;
			}
		case rPeerWindowColorFont:		/* FEtHg̍Đݒ */
			{
				int		does_set_font = LOWORD(lParam);
				twpd->iv_input->ReadRegistry(does_set_font);
				twpd->iv_log_private->ReadRegistry(does_set_font);
				return 0;
			}
		case rPeerWindowLinegap:		/* sԐݒ */
			{
				twpd->iv_input->SetLinegap(); twpd->iv_log_private->SetLinegap();
				return 0;
			}
#ifdef USE_EMACS_KEYBIND
		case rPeerWindowEmacsBinding:	/* EmacsBinding ݒ */
			{
				int		f = LOWORD(lParam);
				lgcRichEdit::KeyBinding k = f ? lgcRichEdit::KeyBindingEmacs : lgcRichEdit::KeyBindingWindows;
				twpd->iv_input->Re.SelectKeyBinding(k);
				twpd->iv_log_private->Re.SelectKeyBinding(k);
				return 0;
			}
#endif
		case rCommandKeyShiftEnter:	/* Shift+Enter L[ꂽ */
			{
				if (twpd->inFocus) {
					CHARRANGE	cr;
					twpd->iv_input->Re.GetSel(&cr);
					int		currentLine = twpd->iv_input->Re.LineFromChar(cr.cpMin);
					int		currentLineTop = twpd->iv_input->Re.LineIndex(currentLine);
					cr.cpMin = cr.cpMax = currentLineTop;
					twpd->iv_input->Re.SetSel(&cr);
					twpd->iv_input->Re.Insert("\r\n", TRUE);
					twpd->iv_input->Re.SetSel(&cr);
				}
				return 0;
			}
		case rCommandKeyEnter:		/* Enter L[ꂽ */
			{
				ItalkView*	iv = iv_get_focused_only_telegram(twpd);	/* Ԃ񂱂 0 ԂȂ */
				/* I-Search ΍ */
				if (iv && iv->Re.IsInIsearchMode()){
					SendMessage(iv->Re.Hwnd(), WM_CHAR, 'M' - '@', 0);
					return 0;
				}
				if (twpd->inFocus /*iv == twpd->iv_input*/){		// M
					if (!witalk2_ptr->freeeditmode) {
						if (witalk2_ptr->iv_send_current_line(FALSE, twpd->iv_input, TRUE, TRUE, twpd->userno)){
							// complete_p() ͕sv
						}
					} else {
						twpd->iv_input->Re.Insert("\r\n", TRUE);
					}
				}
				return 0;
			}
		case rCommandKeyDown:		/* L[ꂽ */
			{
				// obt@Ȃsǉ
				if (iv_get_focused_only_telegram(twpd) == twpd->iv_input){
					int		line_index = twpd->iv_input->Re.LineFromChar(twpd->iv_input->Re.GetCaretIndex());
					if (twpd->iv_input->Re.GetLineCount() - 1 == line_index){
						if (!witalk2_ptr->freeeditmode) {
							twpd->iv_input->Re.MoveCaretToTheLast();
							twpd->iv_input->Re.Insert(L"\r\n");
						}
						return 0;
					}
				}
				witalk2_ptr->send_vkey(iv_get_focused_telegram(twpd)->Re.Hwnd(), VK_DOWN);
				return 0;
			}
		// ҏW (JbgAhy[Xgn) bZ[W
		case rCommandEditUndo:				iv_get_focused_telegram(twpd)->Re.Undo();			return 0;
		case rCommandEditCopy:				iv_get_focused_only_telegram(twpd)->Re.Copy();			return 0;
		case rCommandEditCut:				SendMessage(iv_get_focused_telegram(twpd)->Re.Hwnd(), WM_CUT, 0, 0);			return 0;
		case rCommandEditPaste:				witalk2_ptr->wmCommand_RichEditPaste(false, false, twpd->iv_input, 0); return 0;
		case rCommandEditDelete:			iv_get_focused_telegram(twpd)->Re.Delete();			return 0;
		case rCommandEditQuotedPaste:		witalk2_ptr->wmCommand_RichEditPaste(true,  false, twpd->iv_input, 0); return 0;
		case rCommandEditPasteSendToItalk: case rCommandEditQuotedPasteSendToItalk: case rCommandEditSendToItalk:
			{
				wchar_t		prefix[16];
				if (witalk2_ptr->italk_info.server.is_inid && twpd->userno > 9990) {
					swprintf(prefix, L"%d:", 10000-twpd->userno);	
				} else {
					swprintf(prefix, L"/p %d ", twpd->userno);
				}
				switch (LOWORD(wParam)){
				case rCommandEditPasteSendToItalk:			witalk2_ptr->wmCommand_RichEditPaste(false, true, twpd->iv_input, prefix); break;
				case rCommandEditQuotedPasteSendToItalk:	witalk2_ptr->wmCommand_RichEditPaste(true,  true, twpd->iv_input, prefix); break;
				case rCommandEditSendToItalk:				witalk2_ptr->wmCommand_EditSendToItalk(iv_get_focused_telegram(twpd), twpd->iv_input, prefix); break;
				}
				return 0;
			}
		// tH[JX؂ւ
		case rCommandKeyTab: case rCommandKeySTab: case rCommandKeyCTab: case rCommandKeyCSTab: case rCommandKeyCF6:
			{
				if (iv_get_focused_only_telegram(twpd) == twpd->iv_input){
					SetFocus(twpd->iv_log_private->Re.Hwnd());
				} else if (iv_get_focused_only_telegram(twpd) == twpd->iv_log_private) {
					SetFocus(twpd->iv_input->Re.Hwnd());
				}
				return 0;
			}
		// I[gXN[gO
		case rCommandLogAutoScroll:
			{
				twpd->doesAutoScroll ^= true; return 0;
			}
		// ^H (BS)
		case rCommandKeyCH:
			{
				ItalkView*	iv = iv_get_focused_only_telegram(twpd);
				if (iv){
					if (iv->Re.IsInIsearchMode() || iv == twpd->iv_input){
						keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
						keybd_event(VK_BACK, MapVirtualKey(VK_BACK, 0), 0, 0);
						keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
					}
				}
				return 0;
			}
		// Alt+PgUp / Alt+PgDn (OEBhEXN[)
		case rCommandKeyMNext:
			{
				witalk2_ptr->send_vkey(twpd->iv_log_private->Re.Hwnd(), VK_NEXT);
				return 0;
			}
		case rCommandKeyMPrior:
			{
				witalk2_ptr->send_vkey(twpd->iv_log_private->Re.Hwnd(), VK_PRIOR);
				return 0;
			}
		}
		break;
	case WM_CREATE:				/*  */
		/* Oobt@E̓obt@𐶐 */
		{
			/* [JL̈m */
			TelegramWndProcData* twpd = new TelegramWndProcData;
			SetWindowLongPtr(hwnd, GWLP_USERDATA/*0*/, (LONG_PTR)twpd);
			/* Xvbgo[ */
			twpd->splitbar = CreateWindowEx(NULL, WC_lgcSplitbar, NULL, WS_CHILD | WS_VISIBLE | SBS_HORZ, 0, 0, 300, 300, hwnd, NULL, (HINSTANCE)GetWindowLongPtr(witalk2_ptr->Hwnd(), GWL_HINSTANCE), NULL);
			_ASSERT(twpd->splitbar);
			/* ̓obt@ */
			twpd->iv_input = new ItalkView(twpd->splitbar,witalk2_ptr, &witalk2_ptr->foColorInput, &witalk2_ptr->bkColorInput, ES_AUTOVSCROLL);
			twpd->iv_input->setParentPointer(witalk2_ptr);
			/* Oobt@ */
			twpd->iv_log_private = new ItalkView(twpd->splitbar,witalk2_ptr, &witalk2_ptr->foColorInput, &witalk2_ptr->bkColorLog, ES_AUTOVSCROLL | ES_READONLY);
			twpd->iv_log_private->setParentPointer(witalk2_ptr);
			// Waffle 0.2.1: FƃtHg̍Đݒ
			twpd->iv_input->ReadRegistry(true);
			twpd->iv_log_private->ReadRegistry(true);
			/* Xvbgo[ */
			lgcSplitbar_SetChild(twpd->splitbar, 0, twpd->iv_log_private->Re.Hwnd());
			lgcSplitbar_SetChild(twpd->splitbar, 1, twpd->iv_input->Re.Hwnd());
			/*  */
#ifdef	USE_EMACS_KEYBIND
			twpd->iv_input->Re.EnableEmacsBinding(witalk2_ptr->statusbar);		// EBhẼXe[^Xo[ "I-Search: " Ƃô͂ƕsւȂ
			twpd->iv_log_private->Re.EnableEmacsBinding(witalk2_ptr->statusbar);
			witalk2_ptr->iv_set_keybinding(twpd->iv_input); witalk2_ptr->iv_set_keybinding(twpd->iv_log_private);
			lgcRichEdit::KeyBinding k;
			if (witalk2_ptr->menu.IsChecked(rCommandOtherEmacsKeyBinding)){
				k = lgcRichEdit::KeyBindingEmacs;
			} else {
				k = lgcRichEdit::KeyBindingWindows;
			}
			twpd->iv_input->Re.SelectKeyBinding(k); twpd->iv_log_private->Re.SelectKeyBinding(k);
#endif
			/* TuNX */
			twpd->oldWndProcInput = (WNDPROC)GetWindowLongPtr(twpd->iv_input->Re.Hwnd(), GWLP_WNDPROC);
			twpd->oldWndProcLogPrivate = (WNDPROC)GetWindowLongPtr(twpd->iv_log_private->Re.Hwnd(), GWLP_WNDPROC);
			twpd->iv_input->setSubclass(true);
			twpd->iv_log_private->setSubclass(false);
			SetWindowLongPtr(twpd->iv_input->Re.Hwnd(), GWLP_WNDPROC, (LONG_PTR)TrapTelegramWindowInput);
			SetWindowLongPtr(twpd->iv_log_private->Re.Hwnd(), GWLP_WNDPROC, (LONG_PTR)TrapTelegramWindowLogPrivate);
			return 0;
		}
	case WM_SIZE:				/* EBhETCY */
		{
			int		width = LOWORD(lParam), height = HIWORD(lParam);
			MoveWindow(twpd->splitbar, 0, 0, width, height, true);
			if (!twpd->completedFirstResize){
				twpd->completedFirstResize = true;
				if (twpd->spllayout_valid) lgcSplitbar_SetLayout(twpd->splitbar, twpd->spllayout);
				lgcSplitbar_SetBarPlace(twpd->splitbar, (twpd->splbarplace_valid) ? twpd->splbarplace : height*3/4);
			}
			/* ^XNgC */
			switch(wParam){
			case SIZE_MINIMIZED:
				if (witalk2_ptr->tasktrayIcon && witalk2_ptr->tasktrayStore){
					// WS_EX_TOOLWINDOW ݒ肵 ALT+TAB Ő؂ւȂ悤ɂ
					SetWindowLongPtr(hwnd, GWL_EXSTYLE, (GetWindowLongPtr(hwnd, GWL_EXSTYLE) | WS_EX_TOOLWINDOW) & (~WS_EX_APPWINDOW));
					// ^XNo[폜
					taskbarDelete(hwnd);
				}
				break;
			case SIZE_RESTORED:
				// ^XNo[ɍēo^
				taskbarAdd(hwnd);
				break;
			}
			break;
		}
	case WM_CLOSE:
		{
			telegramWindowClose = true;
			/* EBhEʒuETCYL */
			int		hoge = twpd->userno;
			const char*	hozge2 = twpd->hostname.c_str();
			if (twpd->userno >= 9900 && !twpd->hostname.empty()) {
				ProfileManager* pManager = witalk2_ptr->getProfileManager();
				char	regvalname[BUFSIZE];
                sprintf(regvalname, "Position_%s_%u_%u", twpd->hostname.c_str(), twpd->port, twpd->userno);
				RECT	rc;
				GetWindowRect(hwnd, &rc);
				pManager->Write(regvalname, rc);
				sprintf(regvalname, "Splstyle_%s_%u_%u", twpd->hostname.c_str(), twpd->port, twpd->userno);
				pManager->Write(regvalname, lgcSplitbar_GetLayout(twpd->splitbar, twpd->iv_log_private->Re.Hwnd(), twpd->iv_input->Re.Hwnd()));
				sprintf(regvalname, "Splbarplace_%s_%u_%u", twpd->hostname.c_str(), twpd->port, twpd->userno);
				pManager->Write(regvalname, lgcSplitbar_GetBarPlace(twpd->splitbar));
			}
			/* OAEg */
			if (DoesAutoLogout && witalk2_ptr->servercaps_subroom && twpd->userno > 9900){
				wchar_t		logoutStr[BUFSIZE];
				swprintf(logoutStr, L"/p %d /q\r\n", twpd->userno);
				witalk2_ptr->send_str(logoutStr);
			}
			/* dze[u폜 */
			witalk2_ptr->UnregisterTelegramDeliveryTable(twpd->userno, hwnd);
			/* [JL̈ */
			TelegramWndProcData* twpd = (TelegramWndProcData*)GetWindowLongPtr(hwnd, GWLP_USERDATA /*0*/);
//			delete twpd;		// Waffle 0.2.0f: ߂ȂA[N
			taskbarDelete(hwnd);
			break;
		}
	case WM_DESTROY:			/*  */
		{
			OutputDebugString( "TelegramWndProc WM_DESTROY" );
			// PostQuitMessage(0);	/* ƎvOIĂ܂ */
			telegramWindowClose = true;
			taskbarDelete(hwnd);
			return 0;
		}
	case WM_SETFOCUS:
		{
			/* ̓EBhE Active  */
			SetFocus(twpd->iv_input->Re.Hwnd());
			twpd->inFocus = true;
			return 0;
		}
	case WM_KILLFOCUS:
		{
			twpd->inFocus = false;
			return 0;
		}
	case WM_NOTIFY:
		{
			HWND	notify_hwndfrom = ((LPNMHDR)lParam)->hwndFrom;
			UINT	notify_idfrom = ((LPNMHDR)lParam)->idFrom;
			UINT	notify_code = ((LPNMHDR)lParam)->code;
			if (notify_code != EN_LINK) break;
			UINT	orgmsg = ((ENLINK*)lParam)->msg;
			switch(orgmsg){
			case WM_LBUTTONDOWN:
				if (DialogURL::url_clickmode) break;
			case WM_LBUTTONDBLCLK:
				CHARRANGE	chrg = ((ENLINK*)lParam)->chrg;
				char*		txtbuf_mb = new char[(chrg.cpMax - chrg.cpMin + 16)*2];
				CHARRANGE	orgsel;
				SendMessage(notify_hwndfrom, EM_EXGETSEL, 0, (LPARAM)&orgsel);
				SendMessage(notify_hwndfrom, EM_EXSETSEL, 0, (LPARAM)&chrg);
				SendMessage(notify_hwndfrom, EM_GETSELTEXT, 0, (LPARAM)txtbuf_mb);
				SendMessage(notify_hwndfrom, EM_EXSETSEL, 0, (LPARAM)&orgsel);
				lgFiles::OpenURL(txtbuf_mb, DialogURL::url_bufexecmode);
				delete [] txtbuf_mb;
			}
			break;
		}

	}
	return DefWindowProc(hwnd, iMsg, wParam, lParam);
}

void*	dialogtelegram;

// dETu[ݒ_CAONX =======================================
//
class DialogTelegram : public lgDialog
{
	ProfileManager* m_pProfileManager;
	int		viewNormalTelegram;					// ʏdʃEBhEɔzĂEBhEɕ\邩
	int		viewSubroomTelegram;				// Tu[OʃEBhEɔzĂEBhEɕ\邩
	int		autoOpenNormalTelegram;				// ʏd񓞒ɂĎIɌʃEBhEJ
	int		autoOpenSubroomTelegram;			// Tu[OɂĎIɌʃEBhEJ
	int		doesAutoLogin;						// Tu[ɎOC邩
	int		autoLoginStyle;						// OC` (0 = ftHg̃Tu[̂ / 1 = SẴTu[)
	int		doesAutoLogout;						// Tu[ʃEBhEɎOAEg邩

	BOOL enable_update;

	void adjustButtonStatus()
	{
		EnableWindow(Hwnd(rSubroomAutoLoginDefault), doesAutoLogin); EnableWindow(Hwnd(rSubroomAutoLoginAll), doesAutoLogin);
		if (autoOpenSubroomTelegram){
			Button_SetCheck(Hwnd(rSubroomAutoLogout), false); EnableWindow(Hwnd(rSubroomAutoLogout), false);
			doesAutoLogout = false;
		} else {
			EnableWindow(Hwnd(rSubroomAutoLogout), true);
		}
	}

	void set_all(void)
	{
		//lgRegistry	reg(REGISTRY_ROOT);

		m_pProfileManager->Read("ViewNormalTelegram", viewNormalTelegram, true);
		m_pProfileManager->Read("ViewSubroomTelegram", viewSubroomTelegram, false);
		m_pProfileManager->Read("AutoOpenNormalTelegram", autoOpenNormalTelegram, true);
		m_pProfileManager->Read("AutoOpenSubroomTelegram", autoOpenSubroomTelegram, true);
		m_pProfileManager->Read("DoesAutoLogin", doesAutoLogin, true);
		m_pProfileManager->Read("AutoLoginStyle", autoLoginStyle, 0);
		m_pProfileManager->Read("DoesAutoLogout", doesAutoLogout, false);
	  
		Button_SetCheck(Hwnd(rTelegramCheckViewNormal), viewNormalTelegram);
		Button_SetCheck(Hwnd(rTelegramCheckViewSubroom), viewSubroomTelegram);
		Button_SetCheck(Hwnd(rTelegramAutoOpenNormal), autoOpenNormalTelegram);
		Button_SetCheck(Hwnd(rTelegramAutoOpenSubroom), autoOpenSubroomTelegram);
		Button_SetCheck(Hwnd(rSubroomAutoLogin), doesAutoLogin);
		Button_SetCheck(Hwnd(rSubroomAutoLoginDefault+autoLoginStyle), true);
		Button_SetCheck(Hwnd(rSubroomAutoLogout), doesAutoLogout);

		adjustButtonStatus();
	}

public:
	DialogTelegram(HWND _hwnd) : lgDialog(_hwnd), enable_update(FALSE){ }
  
	// WM_INITDIALOG
	BOOL wmInitDialog(HWND focus, LPARAM lParam)
	{
		if( lParam ){
			PROPSHEETPAGE* pProp = (PROPSHEETPAGE*)lParam;
			m_pProfileManager = (ProfileManager*)pProp->lParam;
		}
		_ASSERT( m_pProfileManager != NULL );

		dialogtelegram = (void*)this;
		set_all();
		return TRUE;
	}

	// WM_COMMAND
	BOOL wmCommand(int notify_code, int id, HWND /* hwnd_control */)
	{
		switch(id){
		case rTelegramCheckViewNormal:		viewNormalTelegram ^= true; return true;
		case rTelegramCheckViewSubroom:		viewSubroomTelegram ^= true; return true;
		case rTelegramAutoOpenNormal:		autoOpenNormalTelegram ^= true; return true;
		case rTelegramAutoOpenSubroom:		autoOpenSubroomTelegram ^= true; adjustButtonStatus(); return true;
		case rSubroomAutoLogin:
			{
				doesAutoLogin ^= true;
				EnableWindow(Hwnd(rSubroomAutoLoginDefault), doesAutoLogin); EnableWindow(Hwnd(rSubroomAutoLoginAll), doesAutoLogin);
				return true;
			}
		case rSubroomAutoLoginDefault:		autoLoginStyle = 0; return true;
		case rSubroomAutoLoginAll:			autoLoginStyle = 1; return true;
		case rSubroomAutoLogout:			doesAutoLogout ^= true; return true;
		case IDCANCEL: return wmClose();

	}
    return TRUE;
  }

	void wmApply()
	{
		{
			//lgRegistry	reg(REGISTRY_ROOT);
			// vt@CɋL^
			m_pProfileManager->Write("ViewNormalTelegram", viewNormalTelegram);
			m_pProfileManager->Write("ViewSubroomTelegram", viewSubroomTelegram);
			m_pProfileManager->Write("AutoOpenNormalTelegram", autoOpenNormalTelegram);
			m_pProfileManager->Write("AutoOpenSubroomTelegram", autoOpenSubroomTelegram);
			m_pProfileManager->Write("DoesAutoLogin", doesAutoLogin);
			m_pProfileManager->Write("AutoLoginStyle", autoLoginStyle);
			m_pProfileManager->Write("DoesAutoLogout", doesAutoLogout);
			// ϐɔf
			dmy.initialize();
		}

	}

	// 
	BOOL wmClose(void)
	{
		EndDialog(Hwnd(), NULL);
		return TRUE;
	}
};

// dETu[֘Aݒ_CAÕ_CAOvV[W =================
//
BOOL CALLBACK DialogTelegramDlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
#define lgWindowClass DialogTelegram
  if (!lgwc)
    switch (message)
    {
      lgwmInitDialog;
    }
  else
    switch (message)
    {
      lgwmCommand;
      lgwmClose;
    }
  if (message == WM_NOTIFY){
	  LPNMHDR	pnmh = (LPNMHDR)lParam;
	  switch(pnmh->code){
	  case PSN_APPLY:
		  {
			  DialogTelegram*	dt = (DialogTelegram*)dialogtelegram;
			  dt->wmApply();
		  }
	  }
  }
  return lgwc->Default(message, wParam, lParam);
}

// Xbh̓o^ (Iɒ~邽) ====================================

