/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgFiles.h


#pragma	once

#include "lgWindows.h"


// SFN  LFN 𓱂
HANDLE GetLongPathName(const char *sfn, char *lfn, int sizeof_lfn);

class lgFiles
{
public:
	// ChJ[h}b`O (UNIX V) 啶ʂȂ
	static BOOL WildMatch(const char *str1, const char *str2);
	// D:\folders\file  file 菜
	static char *GetPath(char *buf);
	// D:\folders\file  file o
	static char *GetName(char *buf);
	// D:\folders\filename\  D:\folders\filename ɂ
	static char *ToName(char *buf);
	// D:\folders  D:\folders\ ɂ
	static char *ToPath(char *buf);
	// path ̘̒A \ 菜
	static char *PackPath(char *path, BOOL does_consider_unc = TRUE);
	// SFN  LFN 𓱂
	static char *GetLongPathName(const char *sfn, char *lfn, int sizeof_lfn, BOOL does_consider_unc = TRUE);
	// st@Cǂɂ邩ׂ
	// (PATH ̒ ; ܂ނ̂Ƃ܂Ȃ)
	static BOOL ResolvePath(const char *filename, char *buf, int sizeof_buf);
	// tH_J_CAO\
	static BOOL OpenFolder(HWND owner_hwnd, const char *title, char *folder, int sizeof_folder);
	// R}hCst@Co
	// commandline  buf ̗̈悪dȂĂĂ悢
	static BOOL CommandlineToCommand(const char *commandline, char *buf, int sizeof_buf);
	// URL J (݂ .html ̂ݑΉ)
	static BOOL OpenURL(const char *url, int openmode);
	// vZXs
	static bool execProcess(const char* program, const char* param, DWORD pri = NORMAL_PRIORITY_CLASS, bool showErr = true);
	static bool execProcess(const char* program, const char* param1, const char* param2, DWORD pri = NORMAL_PRIORITY_CLASS, bool showErr = true);
	// R}hCparse
	static void parseCmdline(const char* s, char* prog, char* param);

	// [fBNg@
	static BOOL MakeDirectory(const char *newdir);
};
