/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgGUIParts.cxx


#include "lgGUIParts.h"


#define x0 rc.left
#define x1 rc.right
#define y0 rc.top
#define y1 rc.bottom


// rc ̊O͂ޘg`
void lgGUIParts::Draw3DFrame(HDC hdc, RECT rc, SortOf3DFrame s,
				     int inside_color)
{
  if (inside_color)
  {
    HBRUSH hbrush = CreateSolidBrush(GetSysColor(inside_color));
    FillRect(hdc, &rc, hbrush);
    DeleteObject(hbrush);
  }
  x0--; y0--;
  switch (s)
  {
    // 3D S̓IɊDF̎̐F
    // COLOR_3DDKSHADOW : 
    // COLOR_3DSHADOW   : ZDF
    // COLOR_3DLIGHT    : DF (COLOR_3DFACE)
    // COLOR_3DHILIGHT  : 
    case FrameDown2:
      draw_3d_frame(hdc, rc, COLOR_3DDKSHADOW, COLOR_3DLIGHT);
      x0--; y0--; x1++; y1++;
      // fall through
    case FrameDown1:
      draw_3d_frame(hdc, rc, COLOR_3DSHADOW, COLOR_3DHILIGHT);
      break;
    case FrameUp1:
    case FrameUp2:
      draw_3d_frame(hdc, rc, COLOR_3DHILIGHT, COLOR_3DSHADOW);
      if (s == FrameUp1)
	break;
      x0--; y0--; x1++; y1++;
      draw_3d_frame(hdc, rc, COLOR_3DLIGHT, COLOR_3DDKSHADOW);
      break;
    case ButtonDown:
      draw_3d_frame(hdc, rc, COLOR_3DSHADOW, COLOR_3DLIGHT);
      x0--; y0--; x1++; y1++;
      draw_3d_frame(hdc, rc, COLOR_3DDKSHADOW, COLOR_3DDKSHADOW);
      break;
    case ButtonUp:
      draw_3d_frame(hdc, rc, COLOR_3DLIGHT, COLOR_3DSHADOW);
      x0--; y0--; x1++; y1++;
      draw_3d_frame(hdc, rc, COLOR_3DHILIGHT, COLOR_3DDKSHADOW);
      break;
  }
}


void lgGUIParts::draw_3d_frame(HDC hdc, RECT &rc, int c0, int c1)
{
  HPEN hpen = (HPEN)SelectObject(hdc, CreatePen(PS_SOLID, 1, GetSysColor(c0)));
  MoveToEx(hdc, x1 - 1, y0    , NULL);
  LineTo  (hdc, x0    , y0    );
  LineTo  (hdc, x0    , y1    );
  DeleteObject(SelectObject(hdc, CreatePen(PS_SOLID, 1, GetSysColor(c1))));
  LineTo  (hdc, x1    , y1    );
  LineTo  (hdc, x1    , y0 - 1);
  DeleteObject(SelectObject(hdc, hpen));
}
