/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgGUIParts.h


#ifndef __lgGUIParts_h__
#define __lgGUIParts_h__


#include "lgWindows.h"


class lgGUIParts
{
  static void draw_3d_frame(HDC hdc, RECT &rc, int c0, int c1);
  
public:
  enum SortOf3DFrame
  {
    FrameUp1,   //  1 ̓ʘg
    FrameDown1, //  1 ̉g
    FrameUp2,   //  2 ̓ʘg
    FrameDown2, //  2 ̉g
    ButtonUp,   //  2 ̉ĂȂ{^g
    ButtonDown  //  2 ̉Ă{^g
  };
  
  // rc ̊O͂ޘg`
  static void Draw3DFrame(HDC hdc, RECT rc, SortOf3DFrame s,
				    int inside_color = 0);
  
  // rc ̓ɘg`
  static void Draw3DFrameInside(HDC hdc, RECT rc, SortOf3DFrame s,
				int inside_color = 0)
  {
    int frame_width = 2 - (int)(s == FrameUp1 || s == FrameDown1);
    rc.left   += frame_width;
    rc.right  -= frame_width;
    rc.top    += frame_width;
    rc.bottom -= frame_width;
    Draw3DFrame(hdc, rc, s, inside_color);
  }
};


#endif // __lgGUIParts_h__
