/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgcToolbar.cxx


#include "lgWindows.h"


// TOOLBAR \[Xǂ Toolbar 쐬
lgcToolbar *lgcToolbar::newCreate
(HWND hwnd_parent,  // eEBhE
 int rToolbar,      // Toolbar ̒`\[X
 int rToolbar16,    // Toolbar  16 F\[X (ʂ rToolbar Ɠ)
 int rToolbar256,   // Toolbar  256 F\[X
 BOOL has_top_sep,  // 擪̌ǂ
 long window_style) // EBhEX^C
{
  if (rToolbar16 == -1)
    rToolbar16 = rToolbar;
  if (rToolbar256 == -1)
    rToolbar256 = rToolbar16;
  
  HGLOBAL htoolbar =
    LoadResource(lgWindows::hInst(),
		 FindResource(lgWindows::hInst(),
			      MAKEINTRESOURCE(rToolbar), RT_TOOLBAR));
  if (!htoolbar)
    return NULL;
  
  HWND hwnd = NULL;

  struct TOOLBAR_RESOURCE // toolbar ̃\[X̍\
  {
    WORD reserved;
    WORD width;
    WORD height;
    WORD num;
    WORD button_id[1];
  } *tb = (TOOLBAR_RESOURCE *)LockResource(htoolbar);
  
  if (tb)
  {
    int n = tb->num;
    for (int i = 0; i < tb->num; i++)
      if (tb->button_id[i] == 0)
	n--;
    int r_toolbar;
    if (16 <= lgGDI::BitsParPixel() && !lgWindows::IsNT())
      r_toolbar = rToolbar256;
    else
      r_toolbar = rToolbar16;
    window_style |= TBSTYLE_FLAT;
    hwnd = CreateToolbarEx(hwnd_parent, window_style, rToolbar, n,
			   lgWindows::hInst(), r_toolbar, NULL, 0, 0, 0,
			   tb->width, tb->height, sizeof(TBBUTTON));
    if (hwnd)
    {
      TBBUTTON tbb;
      tbb.iBitmap = 0;
      tbb.idCommand = 0;
      tbb.fsState = TBSTATE_ENABLED;
      tbb.fsStyle = TBSTYLE_SEP;
      tbb.dwData = 0;
      tbb.iString = NULL;
      if (has_top_sep)
	::SendMessage(hwnd, TB_ADDBUTTONS, (WPARAM)1, (LPARAM)&tbb);
      for (int i = 0, n = 0; i < tb->num; i++)
      {
	if (tb->button_id[i])
	{
	  tbb.iBitmap = n++;
	  tbb.fsStyle = TBSTYLE_BUTTON;
	}
	else
	{
	  tbb.iBitmap = 0;
	  tbb.fsStyle = TBSTYLE_SEP;
	}
	tbb.idCommand = tb->button_id[i];
	::SendMessage(hwnd, TB_ADDBUTTONS, (WPARAM)1, (LPARAM)&tbb);
      }
    }
    UnlockResource(htoolbar);
  }
  return new lgcToolbar(hwnd);
}


// XN[W (x, y) {^ ID Ԃ
int lgcToolbar::HitTest(int x, int y)
{
  POINT p = { x, y };
  ScreenToClient(Hwnd(), &p);
  
  int num = GetButtonCount();
  for (int i = 0; i < num; i++)
  {
    RECT rc;
    SendMessage(TB_GETITEMRECT, (WPARAM)i, (LPARAM)&rc);
    if (rc.left <= p.x && p.x < rc.right &&
	rc.top  <= p.y && p.y < rc.bottom)
    {
      TBBUTTON tbb;
      SendMessage(TB_GETBUTTON, (WPARAM)i, (LPARAM)&tbb);
      return tbb.idCommand;
    }
  }
  return 0;
}


// SẴ{^傫𒲂ׂ
BOOL lgcToolbar::GetButtonsRect(RECT *rc)
{
  int num = GetButtonCount();
  if (num <= 0)
    return FALSE;
  for (int i = 0; i < num; i++)
  {
    RECT _rc;
    GetButtonRect(i, &_rc);
    if (i == 0)
      *rc = _rc;
    else
    {
      rc->left   = min(rc->left  , _rc.left  );
      rc->top    = min(rc->top   , _rc.top   );
      rc->right  = max(rc->right , _rc.right );
      rc->bottom = max(rc->bottom, _rc.bottom);
    }
  }
  return TRUE;
}
